<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.borndie;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.IOException;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.util.ArrayList;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.util.List;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.concurrent.CyclicBarrier;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.util.concurrent.atomic.AtomicLong;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.concurrent.atomic.AtomicReference;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.util.logging.Level;<a name="line.42"></a>
<FONT color="green">043</FONT>    import java.util.logging.Logger;<a name="line.43"></a>
<FONT color="green">044</FONT>    <a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.metabolic.efm.borndie.debug.Debugger;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.metabolic.efm.borndie.debug.NullDebugger;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.metabolic.efm.borndie.job.JobFailedException;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.metabolic.efm.borndie.job.JobManager;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.metabolic.efm.borndie.job.PairingJob;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.metabolic.efm.borndie.matrix.BornDieMatrix;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.metabolic.efm.borndie.matrix.ConcurrentBornDieMatrix;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.metabolic.efm.borndie.memory.ColumnDemuxAppendableMemory;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.metabolic.efm.borndie.model.BornDieEfmModel;<a name="line.53"></a>
<FONT color="green">054</FONT>    import ch.javasoft.metabolic.efm.borndie.range.DefaultCellRange;<a name="line.54"></a>
<FONT color="green">055</FONT>    import ch.javasoft.metabolic.efm.borndie.range.LowerTriangularMatrix;<a name="line.55"></a>
<FONT color="green">056</FONT>    import ch.javasoft.metabolic.efm.column.Column;<a name="line.56"></a>
<FONT color="green">057</FONT>    import ch.javasoft.metabolic.efm.column.ColumnHome;<a name="line.57"></a>
<FONT color="green">058</FONT>    import ch.javasoft.metabolic.efm.config.Config;<a name="line.58"></a>
<FONT color="green">059</FONT>    import ch.javasoft.metabolic.efm.memory.ComposedIterableMemory;<a name="line.59"></a>
<FONT color="green">060</FONT>    import ch.javasoft.metabolic.efm.memory.IterableMemory;<a name="line.60"></a>
<FONT color="green">061</FONT>    import ch.javasoft.metabolic.efm.memory.MemoryFactory;<a name="line.61"></a>
<FONT color="green">062</FONT>    import ch.javasoft.metabolic.efm.model.NetworkEfmModel;<a name="line.62"></a>
<FONT color="green">063</FONT>    import ch.javasoft.util.logging.Loggers;<a name="line.63"></a>
<FONT color="green">064</FONT>    <a name="line.64"></a>
<FONT color="green">065</FONT>    /**<a name="line.65"></a>
<FONT color="green">066</FONT>     * The &lt;code&gt;BornDieController&lt;/code&gt; controls the born/die algorithm. After<a name="line.66"></a>
<FONT color="green">067</FONT>     * instantiating a controller, the algorithm is <a name="line.67"></a>
<FONT color="green">068</FONT>     * {@link #start(IterableMemory) started} by specifying the initial columns. <a name="line.68"></a>
<FONT color="green">069</FONT>     * Multiple threads might be used for the calculation, thus the initiating <a name="line.69"></a>
<FONT color="green">070</FONT>     * thread must {@link #awaitTermination() await termination} to get the result.<a name="line.70"></a>
<FONT color="green">071</FONT>     */<a name="line.71"></a>
<FONT color="green">072</FONT>    public class BornDieController&lt;Col extends Column&gt; {<a name="line.72"></a>
<FONT color="green">073</FONT>            <a name="line.73"></a>
<FONT color="green">074</FONT>            private final Logger LOG = LogPkg.LOGGER;<a name="line.74"></a>
<FONT color="green">075</FONT>            <a name="line.75"></a>
<FONT color="green">076</FONT>            private final Debugger                                          debugger;<a name="line.76"></a>
<FONT color="green">077</FONT>            <a name="line.77"></a>
<FONT color="green">078</FONT>            private final ColumnHome&lt;?, Col&gt;                  columnHome; <a name="line.78"></a>
<FONT color="green">079</FONT>            private final Config                                            config; <a name="line.79"></a>
<FONT color="green">080</FONT>            private final BornDieEfmModel                           model;<a name="line.80"></a>
<FONT color="green">081</FONT>            private final MemoryFactory                             memoryFactory;<a name="line.81"></a>
<FONT color="green">082</FONT>            private final BornDieMatrix&lt;Col&gt;                  matrix;<a name="line.82"></a>
<FONT color="green">083</FONT>            private final JobManager&lt;Col&gt;                             jobManager;<a name="line.83"></a>
<FONT color="green">084</FONT>            private final AtomicReference&lt;Exception&gt;  exception;<a name="line.84"></a>
<FONT color="green">085</FONT>            private final CyclicBarrier                                     barrier;<a name="line.85"></a>
<FONT color="green">086</FONT>            private final AtomicLong                                        time;<a name="line.86"></a>
<FONT color="green">087</FONT>            <a name="line.87"></a>
<FONT color="green">088</FONT>            public BornDieController(ColumnHome&lt;?, Col&gt; columnHome, Config config, BornDieEfmModel model, MemoryFactory memoryFactory) throws IOException {<a name="line.88"></a>
<FONT color="green">089</FONT>                    final LowerTriangularMatrix tril = new LowerTriangularMatrix(model.getIterationCount() + 1);<a name="line.89"></a>
<FONT color="green">090</FONT>                    this.columnHome         = columnHome;<a name="line.90"></a>
<FONT color="green">091</FONT>                    this.config                     = config;<a name="line.91"></a>
<FONT color="green">092</FONT>                    this.debugger           = NullDebugger.INSTANCE;<a name="line.92"></a>
<FONT color="green">093</FONT>    //              this.debugger           = new SwingDebugger(this, tril);<a name="line.93"></a>
<FONT color="green">094</FONT>                    this.model                      = model;<a name="line.94"></a>
<FONT color="green">095</FONT>                    this.memoryFactory      = memoryFactory; <a name="line.95"></a>
<FONT color="green">096</FONT>                    this.matrix             = new ConcurrentBornDieMatrix&lt;Col&gt;(this, tril);<a name="line.96"></a>
<FONT color="green">097</FONT>                    this.jobManager         = new JobManager&lt;Col&gt;(this);<a name="line.97"></a>
<FONT color="green">098</FONT>    //              this.jobManager         = new JobManager&lt;Col&gt;(this, 1024);<a name="line.98"></a>
<FONT color="green">099</FONT>                    this.exception          = new AtomicReference&lt;Exception&gt;();<a name="line.99"></a>
<FONT color="green">100</FONT>                    this.barrier            = new CyclicBarrier(2);<a name="line.100"></a>
<FONT color="green">101</FONT>                    time                            = new AtomicLong(System.currentTimeMillis());<a name="line.101"></a>
<FONT color="green">102</FONT>            }<a name="line.102"></a>
<FONT color="green">103</FONT>            public ColumnHome&lt;?, Col&gt; getColumnHome() {<a name="line.103"></a>
<FONT color="green">104</FONT>                    return columnHome;<a name="line.104"></a>
<FONT color="green">105</FONT>            }<a name="line.105"></a>
<FONT color="green">106</FONT>            public Config getConfig() {<a name="line.106"></a>
<FONT color="green">107</FONT>                    return config;<a name="line.107"></a>
<FONT color="green">108</FONT>            }<a name="line.108"></a>
<FONT color="green">109</FONT>            public NetworkEfmModel getModel() {<a name="line.109"></a>
<FONT color="green">110</FONT>                    return model;<a name="line.110"></a>
<FONT color="green">111</FONT>            }<a name="line.111"></a>
<FONT color="green">112</FONT>            /**<a name="line.112"></a>
<FONT color="green">113</FONT>             * @return the memory factory<a name="line.113"></a>
<FONT color="green">114</FONT>             */<a name="line.114"></a>
<FONT color="green">115</FONT>            public MemoryFactory getMemoryFactory() {<a name="line.115"></a>
<FONT color="green">116</FONT>                    return memoryFactory;<a name="line.116"></a>
<FONT color="green">117</FONT>            }<a name="line.117"></a>
<FONT color="green">118</FONT>            public BornDieMatrix&lt;Col&gt; getMatrix() {<a name="line.118"></a>
<FONT color="green">119</FONT>                    return matrix;<a name="line.119"></a>
<FONT color="green">120</FONT>            }<a name="line.120"></a>
<FONT color="green">121</FONT>            public int getIterationCount() {<a name="line.121"></a>
<FONT color="green">122</FONT>                    return model.getIterationCount();<a name="line.122"></a>
<FONT color="green">123</FONT>            }<a name="line.123"></a>
<FONT color="green">124</FONT>            <a name="line.124"></a>
<FONT color="green">125</FONT>            /**<a name="line.125"></a>
<FONT color="green">126</FONT>             * Adds the pairing job to the job queue. Might block the caller if the job<a name="line.126"></a>
<FONT color="green">127</FONT>             * queue has limited capacity.<a name="line.127"></a>
<FONT color="green">128</FONT>             * <a name="line.128"></a>
<FONT color="green">129</FONT>             * @param job   the job to add to the queue<a name="line.129"></a>
<FONT color="green">130</FONT>             */<a name="line.130"></a>
<FONT color="green">131</FONT>            public void addPairingJob(PairingJob&lt;Col&gt; job) {<a name="line.131"></a>
<FONT color="green">132</FONT>                    try {<a name="line.132"></a>
<FONT color="green">133</FONT>                            jobManager.addJob(job);<a name="line.133"></a>
<FONT color="green">134</FONT>                    }<a name="line.134"></a>
<FONT color="green">135</FONT>                    catch (InterruptedException e) {<a name="line.135"></a>
<FONT color="green">136</FONT>                            throw new RuntimeException(e);<a name="line.136"></a>
<FONT color="green">137</FONT>                    }<a name="line.137"></a>
<FONT color="green">138</FONT>            }<a name="line.138"></a>
<FONT color="green">139</FONT>            <a name="line.139"></a>
<FONT color="green">140</FONT>            /**<a name="line.140"></a>
<FONT color="green">141</FONT>             * Start the born/die algorithm. The algorithm might use multiple threads<a name="line.141"></a>
<FONT color="green">142</FONT>             * and does not block. Use {@link #awaitTermination()} to wait until the<a name="line.142"></a>
<FONT color="green">143</FONT>             * calculation is complete.<a name="line.143"></a>
<FONT color="green">144</FONT>             *  <a name="line.144"></a>
<FONT color="green">145</FONT>             * @param initialColumns        the initial columns from the kernel matrix<a name="line.145"></a>
<FONT color="green">146</FONT>             * @throws IOException  if a i/o exception occurs<a name="line.146"></a>
<FONT color="green">147</FONT>             */<a name="line.147"></a>
<FONT color="green">148</FONT>            public void start(IterableMemory&lt;Col&gt; initialColumns) throws IOException {<a name="line.148"></a>
<FONT color="green">149</FONT>                    final ColumnDemuxAppendableMemory&lt;Col&gt; memory = new ColumnDemuxAppendableMemory&lt;Col&gt;(this, 0);<a name="line.149"></a>
<FONT color="green">150</FONT>                    for (Col col : initialColumns) {<a name="line.150"></a>
<FONT color="green">151</FONT>                            memory.appendColumn(col);<a name="line.151"></a>
<FONT color="green">152</FONT>                    }<a name="line.152"></a>
<FONT color="green">153</FONT>                    matrix.notifyInitialColumnComplete();<a name="line.153"></a>
<FONT color="green">154</FONT>            }<a name="line.154"></a>
<FONT color="green">155</FONT>            <a name="line.155"></a>
<FONT color="green">156</FONT>            /**<a name="line.156"></a>
<FONT color="green">157</FONT>             * Terminates the algorithm<a name="line.157"></a>
<FONT color="green">158</FONT>             */<a name="line.158"></a>
<FONT color="green">159</FONT>            public void terminate() throws IOException {<a name="line.159"></a>
<FONT color="green">160</FONT>                    try {<a name="line.160"></a>
<FONT color="green">161</FONT>                            barrier.await();<a name="line.161"></a>
<FONT color="green">162</FONT>                            final long now  = System.currentTimeMillis();<a name="line.162"></a>
<FONT color="green">163</FONT>                            final long then = time.getAndSet(now);<a name="line.163"></a>
<FONT color="green">164</FONT>                            final LowerTriangularMatrix tril = matrix.getMatrixRange();<a name="line.164"></a>
<FONT color="green">165</FONT>                            final int lastCol = tril.getColumnCount() - 1;<a name="line.165"></a>
<FONT color="green">166</FONT>                            final int modeCount = matrix.getColumnCount(lastCol, tril.getRowTo(lastCol) - 1);<a name="line.166"></a>
<FONT color="green">167</FONT>                            LOG.info("column " + lastCol + " of [0.." + lastCol + "] complete, " + <a name="line.167"></a>
<FONT color="green">168</FONT>                                            modeCount + " new feasible modes, dt=" + (now - then) + "ms.");                         <a name="line.168"></a>
<FONT color="green">169</FONT>                    }<a name="line.169"></a>
<FONT color="green">170</FONT>                    catch (RuntimeException e) {<a name="line.170"></a>
<FONT color="green">171</FONT>                            throw e;<a name="line.171"></a>
<FONT color="green">172</FONT>                    }<a name="line.172"></a>
<FONT color="green">173</FONT>                    catch (Exception e) {<a name="line.173"></a>
<FONT color="green">174</FONT>                            throw new RuntimeException(e);<a name="line.174"></a>
<FONT color="green">175</FONT>                    }               <a name="line.175"></a>
<FONT color="green">176</FONT>            }<a name="line.176"></a>
<FONT color="green">177</FONT>            <a name="line.177"></a>
<FONT color="green">178</FONT>            /**<a name="line.178"></a>
<FONT color="green">179</FONT>             * Blocks the calling thread until the born/die algorithm completes and<a name="line.179"></a>
<FONT color="green">180</FONT>             * returns the memory with the final modes.<a name="line.180"></a>
<FONT color="green">181</FONT>             * <a name="line.181"></a>
<FONT color="green">182</FONT>             * @return the final modes, the algorithm's result<a name="line.182"></a>
<FONT color="green">183</FONT>             * @throws IOException                          if an I/O exception occurred<a name="line.183"></a>
<FONT color="green">184</FONT>             * @throws IllegalStateException        if waiting was interrupted<a name="line.184"></a>
<FONT color="green">185</FONT>             */<a name="line.185"></a>
<FONT color="green">186</FONT>            public IterableMemory&lt;Col&gt; awaitTermination() throws IOException {<a name="line.186"></a>
<FONT color="green">187</FONT>                    try {<a name="line.187"></a>
<FONT color="green">188</FONT>                            barrier.await();<a name="line.188"></a>
<FONT color="green">189</FONT>                            jobManager.terminate();<a name="line.189"></a>
<FONT color="green">190</FONT>                    } <a name="line.190"></a>
<FONT color="green">191</FONT>                    catch (RuntimeException e) {<a name="line.191"></a>
<FONT color="green">192</FONT>                            if (debugger.doDebug()) debugger.notifyException(e);<a name="line.192"></a>
<FONT color="green">193</FONT>                            throw e;<a name="line.193"></a>
<FONT color="green">194</FONT>                    } <a name="line.194"></a>
<FONT color="green">195</FONT>                    catch (IOException e) {<a name="line.195"></a>
<FONT color="green">196</FONT>                            if (debugger.doDebug()) debugger.notifyException(e);<a name="line.196"></a>
<FONT color="green">197</FONT>                            throw e;<a name="line.197"></a>
<FONT color="green">198</FONT>                    }<a name="line.198"></a>
<FONT color="green">199</FONT>                    catch (Exception e) {<a name="line.199"></a>
<FONT color="green">200</FONT>                            if (debugger.doDebug()) debugger.notifyException(e);<a name="line.200"></a>
<FONT color="green">201</FONT>                            throw new RuntimeException(e);<a name="line.201"></a>
<FONT color="green">202</FONT>                    }<a name="line.202"></a>
<FONT color="green">203</FONT>                    //collect columns in last matrix row<a name="line.203"></a>
<FONT color="green">204</FONT>                    final int len = matrix.getMatrixRange().getLength();<a name="line.204"></a>
<FONT color="green">205</FONT>            final List&lt;IterableMemory&lt;Col&gt;&gt; lastRow = new ArrayList&lt;IterableMemory&lt;Col&gt;&gt;(len);<a name="line.205"></a>
<FONT color="green">206</FONT>            for (int i = 0; i &lt; len; i++) {<a name="line.206"></a>
<FONT color="green">207</FONT>                            lastRow.add(matrix.getFinal(i));<a name="line.207"></a>
<FONT color="green">208</FONT>                    }<a name="line.208"></a>
<FONT color="green">209</FONT>                    final IterableMemory&lt;Col&gt; res = new ComposedIterableMemory&lt;Col&gt;(lastRow);<a name="line.209"></a>
<FONT color="green">210</FONT>                    debugger.notifyTerminate(jobManager, res);<a name="line.210"></a>
<FONT color="green">211</FONT>                    if (Loggers.isLoggable(LOG, Level.FINE)) {<a name="line.211"></a>
<FONT color="green">212</FONT>                            LOG.fine(jobManager.toString());<a name="line.212"></a>
<FONT color="green">213</FONT>                    }<a name="line.213"></a>
<FONT color="green">214</FONT>                    return res;<a name="line.214"></a>
<FONT color="green">215</FONT>            }<a name="line.215"></a>
<FONT color="green">216</FONT>            <a name="line.216"></a>
<FONT color="green">217</FONT>            public void switchColumnToBearingStage(int bornColumn) throws IOException {<a name="line.217"></a>
<FONT color="green">218</FONT>                    final long now  = System.currentTimeMillis();<a name="line.218"></a>
<FONT color="green">219</FONT>                    final long then = time.getAndSet(now);<a name="line.219"></a>
<FONT color="green">220</FONT>                    final LowerTriangularMatrix tril = matrix.getMatrixRange();<a name="line.220"></a>
<FONT color="green">221</FONT>                    final int activeRows = Math.max(0, tril.getColumnHeight(bornColumn) - 2);               <a name="line.221"></a>
<FONT color="green">222</FONT>                    final int adjThreads = config.getMaxThreads() &gt;&gt;&gt; Math.min(<a name="line.222"></a>
<FONT color="green">223</FONT>                            31 - Integer.numberOfLeadingZeros(config.getMaxThreads()), activeRows);<a name="line.223"></a>
<FONT color="green">224</FONT>                    model.setAdjEnumThreads(Math.max(1, adjThreads));<a name="line.224"></a>
<FONT color="green">225</FONT>                    final int rowFrom       = tril.getRowFrom(bornColumn);<a name="line.225"></a>
<FONT color="green">226</FONT>                    final int rowTo         = tril.getRowTo(bornColumn);<a name="line.226"></a>
<FONT color="green">227</FONT>                    int modeCountTotal = 0;<a name="line.227"></a>
<FONT color="green">228</FONT>                    for (int r = rowFrom; r &lt; rowTo; r++) {<a name="line.228"></a>
<FONT color="green">229</FONT>                            final int modeCount = matrix.getColumnCount(bornColumn, r);<a name="line.229"></a>
<FONT color="green">230</FONT>                            modeCountTotal += modeCount;<a name="line.230"></a>
<FONT color="green">231</FONT>                            if (tril.isFinalRow(r)) {<a name="line.231"></a>
<FONT color="green">232</FONT>                                    LOG.info("column " + bornColumn + " of [0.." + <a name="line.232"></a>
<FONT color="green">233</FONT>                                            (tril.getColumnCount() - 1) + "] now bearing, with " +<a name="line.233"></a>
<FONT color="green">234</FONT>                                            model.getAdjEnumThreads() + " threads and " + <a name="line.234"></a>
<FONT color="green">235</FONT>                                            modeCountTotal + " modes, " + modeCount + " new feasible, dt=" + (now - then) + "ms.");                         <a name="line.235"></a>
<FONT color="green">236</FONT>                            }<a name="line.236"></a>
<FONT color="green">237</FONT>                            else {<a name="line.237"></a>
<FONT color="green">238</FONT>                                    if (Loggers.isLoggable(LOG, Level.FINEST)) {<a name="line.238"></a>
<FONT color="green">239</FONT>                                            LOG.finer("cell " + new DefaultCellRange(bornColumn, r) + " has collected all modes: " + matrix.getColumnCount(bornColumn, r));<a name="line.239"></a>
<FONT color="green">240</FONT>                                    }<a name="line.240"></a>
<FONT color="green">241</FONT>                            }<a name="line.241"></a>
<FONT color="green">242</FONT>                    }<a name="line.242"></a>
<FONT color="green">243</FONT>                    <a name="line.243"></a>
<FONT color="green">244</FONT>                    for (int r = rowFrom; r &lt; rowTo; r++) {<a name="line.244"></a>
<FONT color="green">245</FONT>                            if (!tril.isFinalRow(r)) {<a name="line.245"></a>
<FONT color="green">246</FONT>                                    matrix.schedulePairingJobs(bornColumn, r, 0, bornColumn + 1);<a name="line.246"></a>
<FONT color="green">247</FONT>                            }<a name="line.247"></a>
<FONT color="green">248</FONT>                    }<a name="line.248"></a>
<FONT color="green">249</FONT>                    <a name="line.249"></a>
<FONT color="green">250</FONT>                    for (int c = 0; c &lt; bornColumn; c++) {<a name="line.250"></a>
<FONT color="green">251</FONT>                            final int rFrom = tril.getRowFrom(bornColumn);<a name="line.251"></a>
<FONT color="green">252</FONT>                            final int rTo   = tril.getRowTo(c);<a name="line.252"></a>
<FONT color="green">253</FONT>                            for (int r = rFrom; r &lt; rTo; r++) {<a name="line.253"></a>
<FONT color="green">254</FONT>                                    if (!tril.isFinalRow(r)) {<a name="line.254"></a>
<FONT color="green">255</FONT>                                            matrix.schedulePairingJobs(c, r, bornColumn, bornColumn + 1);<a name="line.255"></a>
<FONT color="green">256</FONT>                                    }<a name="line.256"></a>
<FONT color="green">257</FONT>                            }<a name="line.257"></a>
<FONT color="green">258</FONT>                    }<a name="line.258"></a>
<FONT color="green">259</FONT>            }<a name="line.259"></a>
<FONT color="green">260</FONT>            <a name="line.260"></a>
<FONT color="green">261</FONT>            /**<a name="line.261"></a>
<FONT color="green">262</FONT>             * Handle an exception which occurred in a pairing job executed in its own<a name="line.262"></a>
<FONT color="green">263</FONT>             * thread. If it was the first exception, it is kept and rethrown after <a name="line.263"></a>
<FONT color="green">264</FONT>             * terminating the algorithm.<a name="line.264"></a>
<FONT color="green">265</FONT>             * <a name="line.265"></a>
<FONT color="green">266</FONT>             * @param job   the job that caused the exception<a name="line.266"></a>
<FONT color="green">267</FONT>             * @param e             the exception which occurred<a name="line.267"></a>
<FONT color="green">268</FONT>             */<a name="line.268"></a>
<FONT color="green">269</FONT>            public void handleJobException(PairingJob&lt;Col&gt; job, Exception e) {<a name="line.269"></a>
<FONT color="green">270</FONT>                    handleCommandException(new JobFailedException(job, e));<a name="line.270"></a>
<FONT color="green">271</FONT>            }<a name="line.271"></a>
<FONT color="green">272</FONT>            /**<a name="line.272"></a>
<FONT color="green">273</FONT>             * Handle an exception which occurred in a command executed in its own <a name="line.273"></a>
<FONT color="green">274</FONT>             * thread. If it was the first exception, it is kept and rethrown after <a name="line.274"></a>
<FONT color="green">275</FONT>             * terminating the algorithm.<a name="line.275"></a>
<FONT color="green">276</FONT>             * <a name="line.276"></a>
<FONT color="green">277</FONT>             * @param e             the exception which occurred<a name="line.277"></a>
<FONT color="green">278</FONT>             */<a name="line.278"></a>
<FONT color="green">279</FONT>            public void handleCommandException(Exception e) {<a name="line.279"></a>
<FONT color="green">280</FONT>                    exception.compareAndSet(null, e);<a name="line.280"></a>
<FONT color="green">281</FONT>                    try {<a name="line.281"></a>
<FONT color="green">282</FONT>                            terminate();<a name="line.282"></a>
<FONT color="green">283</FONT>                    }<a name="line.283"></a>
<FONT color="green">284</FONT>                    catch (IOException inner) {<a name="line.284"></a>
<FONT color="green">285</FONT>                            //ignore<a name="line.285"></a>
<FONT color="green">286</FONT>                    }               <a name="line.286"></a>
<FONT color="green">287</FONT>            }<a name="line.287"></a>
<FONT color="green">288</FONT>            <a name="line.288"></a>
<FONT color="green">289</FONT>            /**<a name="line.289"></a>
<FONT color="green">290</FONT>             * Returns the exception, if one has been set, or {@code null} otherwise.<a name="line.290"></a>
<FONT color="green">291</FONT>             */<a name="line.291"></a>
<FONT color="green">292</FONT>            public Exception getException() {<a name="line.292"></a>
<FONT color="green">293</FONT>                    return exception.get();<a name="line.293"></a>
<FONT color="green">294</FONT>            }<a name="line.294"></a>
<FONT color="green">295</FONT>    <a name="line.295"></a>
<FONT color="green">296</FONT>            public Debugger getDebugger() {<a name="line.296"></a>
<FONT color="green">297</FONT>                    return debugger;<a name="line.297"></a>
<FONT color="green">298</FONT>            }<a name="line.298"></a>
<FONT color="green">299</FONT>            <a name="line.299"></a>
<FONT color="green">300</FONT>    }<a name="line.300"></a>




























































</PRE>
</BODY>
</HTML>
